<?php

$password = 'pass';

$accountCount = 10;
$albumCount = 10;
$songCount = 10;

$albumPath = './static/image';
$albums = scandir($albumPath);
$albums = array_diff($albums, ['.', '..']);

$songPath = './static/audio';
$songs = scandir($songPath);
$songs = array_diff($songs, ['.', '..']);

for ($i = 0; $i < $accountCount; $i++) {
    $username = 'xxx-'. $i+1;
    $query = "INSERT INTO account (username, password, is_admin) VALUES(:username, :password, :isAdmin)
                RETURNING account_id";
    $params = [
        'username' => $username,
        'password' => '$2y$10$tnk8QA1iIcfkfOlGyhhXX.fnP/BgP8ziwwR6sftDNAdxEyEOkioqy', // plats
        'isAdmin' => 1
    ];

    $res = execSelect($query, $params);
    $accountId = $res[0]['account_id'];
    for ($j = 0; $j < $albumCount; $j++) {
        $albumCover = $albumPath . '/' . $albums[array_rand($albums)];
        $albumId = addAlbum($accountId, 'album-'.$j, '2023',
            bin2hex(random_bytes(10)), $albumCover);
        for ($k = 0; $k < $songCount; $k++) {
            $song = $songPath . '/' . $songs[array_rand($songs)];
            addMusic($accountId, 'title-'.$k, 'genre', '2023',
            $albumId, bin2hex(random_bytes(10)), $song);
        }
    }
}

function hashPassword(string $password): string {
    $pepper = 'wbd';
    return password_hash($password.$pepper, PASSWORD_BCRYPT);
}

function execute(string $query, array $params): void {
    try {
        $pdo = getConn();

        $sth = $pdo->prepare($query, [PDO::ATTR_CURSOR => PDO::CURSOR_FWDONLY]);
        $sth->execute($params);
    } catch (PDOException $exception) {
        echo $exception;
        die();
    }
}

function execSelect(string $query, array $params): array {
    try {
        $pdo = getConn();

        $sth = $pdo->prepare($query, [PDO::ATTR_CURSOR => PDO::CURSOR_FWDONLY]);
        $sth->execute($params);
        return $sth->fetchAll();
    } catch (PDOException $exception) {
        echo $exception;

        die();
    }
}

function getConn(): PDO {
    $host = 'localhost';
    $dbname = 'web';
    $username = 'web';
    $password = 'web';

    $pdo = new PDO("pgsql:host=$host;dbname=$dbname",
        $username, $password);

    $pdo->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);
    return $pdo;
}

function getDuration($filename): int {
    $dur = shell_exec("ffmpeg -i $filename 2>&1 | grep Duration | cut -d ' ' -f 4 | sed s/,//");
    $dur = explode(':', $dur);

    return (int) $dur[0] * 3600 + (int) $dur[1] * 60 + (int) $dur[2];
}

function addMusic(string $accountId, string $title, string $genre, string $year, string $albumId,
                  string $fileName, string $path): int {
    $fileName = str_replace(' ', '', $fileName);

    // upload the file
    $curl = curl_init();
    curl_setopt($curl, CURLOPT_URL, 'localhost:8009/object');

    // form the request
    curl_setopt($curl, CURLOPT_POST, true);
    curl_setopt(
        $curl,
        CURLOPT_POSTFIELDS,
        array(
            'file' => new CURLFile($path),
            'password'  => getenv('OBJ_STORAGE_PASS'),
            'owner' => $accountId, // account id,
            'fileType' => 'music',
            'fileName' => $fileName
        ));

    // execute the request
    curl_exec($curl);
    $http_code = curl_getinfo($curl, CURLINFO_HTTP_CODE);
    curl_reset($curl);

    $duration = getDuration($path);

    if ($http_code == 200) {
        $query = 'INSERT INTO music (title, album_id, genre, year, duration, owner_account_id, music_filename) 
                    VALUES(:title, :albumId, :genre, :year, :duration, :accountId, :fileName)';
        $params = [
            'title' => $title,
            'year' => $year,
            'duration' => $duration,
            'albumId' => $albumId,
            'genre' => $genre,
            'fileName' => $fileName,
            'accountId' => $accountId
        ];
        execute($query, $params);
        // delete the file if insert didn't succeed
    }
    curl_close($curl);
    return $http_code;
}

function addAlbum(string $accountId, string $albumName, string $year, string $fileName, string $path): string {
    $fileName = str_replace(' ', '', $fileName);

    // upload the file
    $curl = curl_init();
    curl_setopt($curl, CURLOPT_URL, 'localhost:8009/object');

    // form the request
    curl_setopt($curl, CURLOPT_POST, true);
    curl_setopt(
        $curl,
        CURLOPT_POSTFIELDS,
        array(
            'file' => new CURLFile($path),
            'password'  => getenv('OBJ_STORAGE_PASS'),
            'owner' => $accountId, // account id,
            'fileType' => 'album-cover',
            'fileName' => $fileName
        ));

    // execute the request
    curl_exec($curl);
    $http_code = curl_getinfo($curl, CURLINFO_HTTP_CODE);

    if ($http_code == 200) {
        $query = 'INSERT INTO album (name, year, album_cover_filename, owner_account_id) 
                        VALUES(:name, :year, :fileName, :accountId)
                        RETURNING album_id';
        $params = [
            'name' => $albumName,
            'year' => $year,
            'fileName' => $fileName,
            'accountId' => $accountId
        ];

        $res = execSelect($query, $params);
        curl_close($curl);
        return $res[0]['album_id'];
    }

    return '';
}