<?php

require_once 'auth/authorizer.php';
require_once 'auth/token.php';
require_once 'db/db-executor.php';
require_once 'crypto/password.php';

function registerAccount(string $username, string $password, bool $admin, string $email): string {
    $query = "INSERT INTO account (username, password, is_admin, email) 
                VALUES(:username, :password, :isAdmin, :email) RETURNING account_id";
    $params = [
        'username' => $username,
        'password' => hashPassword($password),
        'isAdmin' => (int) $admin,
        'email' => $email
    ];

    $res = execSelect($query, $params);
    return getToken($res[0]['account_id']);
}