<?php

if ($_SERVER['REQUEST_METHOD'] == 'GET') {
    $checkSubsUrl = 'http://node:3000/services/relaxed/subscription/'.$_GET['id'];
    $checkSubsResp = file_get_contents($checkSubsUrl);

    $subsData = json_decode($checkSubsResp, true);
    if ($subsData === null && json_last_error() !== JSON_ERROR_NONE) {
        exit();
    }

    if (!isset($subsData['success']) || !isset($subsData['message'])) {
        exit();
    }

    $checked = false;
    $subscribed = true;
    if (!$subsData['success']) {
        $checked = true;
        $subscribed = false;
    }

    if (!$checked) {
        $checked = true;
        $message = $subsData['message'];
        if (isset($message['paid']) && !$message['paid']) {
            $subscribed = false;
        }
    }

    $query = execSelect("SELECT owner_account_id, music_filename FROM music WHERE music_id = :id", ['id' => $_GET['id']]);
    $accountId = $query[0]['owner_account_id'];
    $fileName = $query[0]['music_filename'];

    $params = http_build_query(array(
        'owner' => $accountId, // account id,
        'fileType' => 'music',
        'fileName' => $fileName
    ));

    $curl = curl_init('object-storage:80/object?'.$params);
    curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
    $result = curl_exec($curl);

    $ads = null;
    if (!$subscribed) {
        $ad_param = http_build_query(array(
            'owner' => 'company',
            'fileType' => 'ads',
            'fileName' => 'ads.mp3'
        ));
        $curl = curl_init('object-storage:80/object?'.$ad_param);
        curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
        $ads = curl_exec($curl);
    }

    if (!curl_errno($curl) && curl_getinfo($curl, CURLINFO_HTTP_CODE) == 200) {
        $contentType = curl_getinfo($curl, CURLINFO_CONTENT_TYPE);
        $data = 'data:'.$contentType.';base64,'.base64_encode($result);
        $ads_data = 'data:'.$contentType.';base64,'.base64_encode($ads);

        $arr_data = ['data' => $data];
        if (!$subscribed) {
            $arr_data['ads'] = $ads_data;
        }
        echo json_encode($arr_data);
    }
    curl_close($curl);
}