<?php

require_once 'db/db-executor.php';
require_once 'auth/authenticator.php';

$errMsg = '';


try {
    switch ($_SERVER['REQUEST_METHOD']) {
        case 'GET':
            // Get the full URL including additional parameters
            $fullUrl = $_SERVER['REQUEST_URI'];

            // Split the URL to separate the base route and parameters
            $parts = explode('?', $fullUrl);

            // Extract the base route (e.g., /album/fetch/)
            $baseRoute = $parts[0];

            // Extract and parse the query parameters
            $queryString = isset($parts[1]) ? $parts[1] : '';
            parse_str($queryString, $queryParams);

            // Extract individual parameters
            $csrfToken = $queryParams['csrf_token']; // 'sdfb435'
            $searchQuery = $queryParams['q']; // 'beethoven'

            // Prevent CSRF Attacks
            if(!authenticateToken($csrfToken)) {
                http_response_code(401);
                exit;
            }

            $query = 'SELECT * FROM account WHERE username LIKE :searchQuery';
            $params = ['searchQuery' => '%'.$searchQuery.'%'];

            $res = execSelect($query, $params);


            header('Content-Type: application/json');
            http_response_code(200);
            echo json_encode($res);
            exit;

            break;
        default:
            http_response_code(401);
            exit;
    }
} catch (Exception $e) {
    http_response_code($e->getCode());
    exit;
}
