<?php

require_once 'conn-publisher.php';

function execSelect(string $query, array $params): array {
    try {
        $pdo = getConn();

        $sth = $pdo->prepare($query, [PDO::ATTR_CURSOR => PDO::CURSOR_FWDONLY]);
        $sth->execute($params);
        return $sth->fetchAll();
    } catch (PDOException $exception) {
        header('Location: /500', true, 303);
        die();
    }
}

function execSelect_KeyField(string $query, array $params): array {
    try {
        $pdo = getConn();

        $sth = $pdo->prepare($query, [PDO::ATTR_CURSOR => PDO::CURSOR_FWDONLY]);
        $sth->execute($params);
        return $sth->fetchAll(PDO::FETCH_ASSOC);
    } catch (PDOException $exception) {
        header('Location: /500', true, 303);
        die();
    }
}

function execSelect_ManualErrHandling(string $query, array $params): false|array {
    $pdo = getConn();

    $sth = $pdo->prepare($query, [PDO::ATTR_CURSOR => PDO::CURSOR_FWDONLY]);
    $sth->execute($params);
    return $sth->fetchAll();
}

function execute(string $query, array $params): void {
    try {
        $pdo = getConn();

        $sth = $pdo->prepare($query, [PDO::ATTR_CURSOR => PDO::CURSOR_FWDONLY]);
        $sth->execute($params);
    } catch (PDOException $exception) {
        header('Location: /500', true, 303);
        die();
    }
}

function execute_ManualErrHandling(string $query, array $params): bool {
    try {
        $pdo = getConn();

        $sth = $pdo->prepare($query, [PDO::ATTR_CURSOR => PDO::CURSOR_FWDONLY]);
        $sth->execute($params);
        return true;
    } catch (PDOException $exception) {
        return false;
    }
}