<?php

function addAlbum(string $accountId, string $albumName, string $year): int {
    $fileName = $_FILES['file']['name'];
    $fileName = str_replace(' ', '', $fileName);

    if($_FILES['file']['size'] > 15485760) {
        header('Location: /album/add?err=2', true, 303);
        exit();
    }

    // upload the file
    $curl = curl_init();
    curl_setopt($curl, CURLOPT_URL, 'object-storage:80/object');

    // form the request
    curl_setopt($curl, CURLOPT_POST, true);
    curl_setopt(
        $curl,
        CURLOPT_POSTFIELDS,
        array(
            'file' => new CURLFile($_FILES['file']['tmp_name']),
            'password'  => getenv('OBJ_STORAGE_PASS'),
            'owner' => $accountId, // account id,
            'fileType' => 'album-cover',
            'fileName' => $fileName
        ));

    // execute the request
    curl_exec($curl);
    $http_code = curl_getinfo($curl, CURLINFO_HTTP_CODE);

    if ($http_code == 200) {
        $query = 'INSERT INTO album (name, year, album_cover_filename, owner_account_id) 
                        VALUES(:name, :year, :fileName, :accountId)';
        $params = [
            'name' => $albumName,
            'year' => $year,
            'fileName' => $fileName,
            'accountId' => $accountId
        ];

        $res = execute_ManualErrHandling($query, $params);
        // delete the file if insert didn't succeed
        if (!$res) {
            curl_setopt($curl, CURLOPT_URL, 'object-storage:80/object');
            curl_setopt($curl, CURLOPT_CUSTOMREQUEST, 'DELETE');
            curl_setopt(
                $curl,
                CURLOPT_POSTFIELDS,
                http_build_query(
                    array(
                        'password'  => getenv('OBJ_STORAGE_PASS'),
                        'owner' => $accountId, // account id,
                        'fileType' => 'album-cover',
                        'fileName' => $fileName
                    )
                ));
            curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
            curl_exec($curl); // assume this request will always succeed

            return 500;
        }
    }
    curl_close($curl);
    return $http_code;
}