<?php

function getDuration($filename): int {
    $dur = shell_exec("ffmpeg -i $filename 2>&1 | grep Duration | cut -d ' ' -f 4 | sed s/,//");
    $dur = explode(':', $dur);

    if (!isset($dur[0]) || !isset($dur[1]) || !isset($dur[2])) {
        header('Location: /music/add?err=2', true, 303);
        exit();
    }

    return (int) $dur[0] * 3600 + (int) $dur[1] * 60 + (int) $dur[2];
}

function addMusic(string $accountId, string $title, string $genre, string $year, string $albumId): int {
    $fileName = $_FILES['file']['name'];
    $fileName = str_replace(' ', '', $fileName);

    if (!isAlbumValid($albumId, $accountId)) {
        return 450;
    }

    if($_FILES['file']['size'] > 120485760) {
        header('Location: /music/add?err=2', true, 303);
        exit();
    }

    // upload the file
    $curl = curl_init();
    curl_setopt($curl, CURLOPT_URL, 'object-storage:80/object');

    // form the request
    curl_setopt($curl, CURLOPT_POST, true);
    curl_setopt(
        $curl,
        CURLOPT_POSTFIELDS,
        array(
            'file' => new CURLFile($_FILES['file']['tmp_name']),
            'password'  => getenv('OBJ_STORAGE_PASS'),
            'owner' => $accountId, // account id,
            'fileType' => 'music',
            'fileName' => $fileName
        ));

    // execute the request
    curl_exec($curl);
    $http_code = curl_getinfo($curl, CURLINFO_HTTP_CODE);
    curl_reset($curl);

    $duration = getDuration($_FILES['file']['tmp_name']);

    if ($http_code == 200) {
        $query = 'INSERT INTO music (title, album_id, genre, year, duration, owner_account_id, music_filename) 
                    VALUES(:title, :albumId, :genre, :year, :duration, :accountId, :fileName)';
        $params = [
            'title' => $title,
            'year' => $year,
            'duration' => $duration,
            'albumId' => $albumId,
            'genre' => $genre,
            'fileName' => $fileName,
            'accountId' => $accountId
        ];

        $res = execute_ManualErrHandling($query, $params);
        // delete the file if insert didn't succeed
        if (!$res) {
            curl_setopt($curl, CURLOPT_URL, 'object-storage:80/object');
            curl_setopt($curl, CURLOPT_CUSTOMREQUEST, 'DELETE');
            curl_setopt(
                $curl,
                CURLOPT_POSTFIELDS,
                http_build_query(
                    array(
                        'password'  => getenv('OBJ_STORAGE_PASS'),
                        'owner' => $accountId, // account id,
                        'fileType' => 'music',
                        'fileName' => $fileName
                    )
                ));
            curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
            curl_exec($curl); // assume this request will always succeed

            return 500;
        }
    }
    curl_close($curl);

    return $http_code;
}
