const isEmailValid = (email) => {
    return email.match(
        /^(([^<>()[\]\\.,;:\s@\"]+(\.[^<>()[\]\\.,;:\s@\"]+)*)|(\".+\"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/
    );
};

function validate() {
    let username = document.forms["form"]["username"].value;
    let email = document.forms["form"]["email"].value;
    let password = document.forms["form"]["password"].value;
    let valid = true, errMsg = '';

    if (username === "" || password === "" || email === "") {
        errMsg = "Both username and password are required fields.";
        valid = false;
    }

    if (username.length > 30) {
        errMsg = "Username must be less than 30 characters.";
        valid = false;
    }

    if (valid && !isEmailValid(email)) {
        errMsg = "Email format is invalid.";
        valid = false;
    }

    if (valid && password.length > 30) {
        errMsg = "Password must be less than 30 characters.";
        valid = false;
    }

    if (!valid) {
        document.getElementById('err-msg').textContent = errMsg;
    }
    return valid;
}