function isInt(num) {
    return !isNaN(num) && !isNaN(parseInt(num));
}

function validate() {
    let title = document.forms["form"]["title"].value;
    let year = document.forms["form"]["year"].value;
    let valid = true, errMsg = '';

    if (title === "" || year === "") {
        errMsg = "Please fill all the fields.";
        valid = false;
    }

    if (title.length > 255) {
        errMsg = "Album title must be less than 256 characters.";
        valid = false;
    }

    if (valid && (!isInt(year) || (isInt(year) && year < 0))) {
        errMsg = "Invalid year";
        valid = false;
    }

    const fileSize = document.forms["form"]["input-file"].files[0].size / 1024 / 1024;
    if (fileSize > 15) {
        errMsg = "File size exceeds 15 MB limit";
        valid = false;
    }

    if (!valid) {
        document.getElementById('err-msg').textContent = errMsg;
    }
    return valid;
}