<?php

require_once 'auth/authorizer.php';

$accountId = authorizeAdmin($_COOKIE['token']);
if (!$accountId) {
    header('Location: /404', true, 303);
    exit(); // invalid token
}

function getAlbumID(mixed $album_name) {
    $result = execSelect("SELECT album_id FROM album WHERE name = :name", ['name' => $album_name]);

    if (count($result) == 0) {
        echo "<script>alert(\"Album not found\")</script>";
        exit;
    }

    return $result[0]['album_id'];
}

if ($_SERVER["REQUEST_METHOD"] == "GET") {
    require 'presentation/music/edit/editMusic.view.php';
} else if ($_SERVER["REQUEST_METHOD"] == "POST") {
    execute("UPDATE music SET title = :title/*, artist = :artist*/, album_id = :album_id, genre = :genre, year = :year WHERE music_id = :id",
        ['title' => $_POST['title'],
//            'artist' => $_POST['artist'],
            'album_id' => getAlbumID($_POST['album']),
            'genre' => $_POST['genre'],
            'year' => $_POST['year'],
            'id' => $_POST['id']
        ]
    );

    header('Location: /music/edit?id=' . $_POST['id'], true, 303);
} else if ($_SERVER["REQUEST_METHOD"] == "DELETE") {
    $data = json_decode(file_get_contents('php://input'), true);
    $curl = curl_init('object-storage:80/object');

    curl_setopt($curl, CURLOPT_CUSTOMREQUEST, 'DELETE');
    curl_setopt(
        $curl,
        CURLOPT_POSTFIELDS,
        http_build_query(
            array(
                'password'  => getenv('OBJ_STORAGE_PASS'),
                'owner' => $data['account_id'], // account id,
                'fileType' => 'music',
                'fileName' => $data['filename']
            )
        ));
    curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
    curl_exec($curl);

    execute("DELETE FROM music WHERE music_id = :id", ['id' => $data['id']]);

    header('Location: /music/edit?id=' . $data['id'], true, 303);
}