const form = document.querySelector('#form');
const title = document.querySelector('#input-title');
const artist = document.querySelector('#input-artist');
const album = document.querySelector('#input-album');
const year = document.querySelector('#input-year');
const genre = document.querySelector('#input-genre');

form.addEventListener('submit', (e) => {
    if (!title.value || !artist.value || !album.value || !year.value || !genre.value) {
        e.preventDefault();
        alert('Please fill out all the required fields!');
    } else if (!Number.isInteger(parseInt(year.value)) || parseInt(year.value) < 0) {
        e.preventDefault();
        alert('Please enter a valid year!');
    }
});

function getCookie(name) {
    const value = `; ${document.cookie}`;
    const parts = value.split(`; ${name}=`);
    if (parts.length === 2) return parts.pop().split(';').shift();
}

function deleteMusic(filename, musicId) {
    if (!confirm('Are you sure you want to delete this music?')) {
        return;
    }

    let url = '/music/edit';
    let xhr = new XMLHttpRequest();

    let data = {
        account_id: getCookie('account_id'),
        filename: filename,
        id: musicId
    }

    xhr.open('DELETE', url, true);
    xhr.setRequestHeader('Content-Type', 'application/json');
    xhr.onreadystatechange = function() {
        if (xhr.readyState === 4 && xhr.status === 200) {
            alert('Music deleted!');
        }
    }

    xhr.send(JSON.stringify(data));
}