const listItems = document.querySelector('#music-list').getElementsByTagName('li');
const editButtons = document.querySelector('#music-list').getElementsByClassName('edit-music');
const audioPlayer = document.querySelector('#audio');

for (let item of listItems) {
    item.addEventListener('click', (e) => {
        e.preventDefault();

        let id = item.id;
        let xhr = new XMLHttpRequest();

        const url = "/audio?id="+id

        xhr.open('GET', url, true)
        xhr.onreadystatechange = function() {
            if (xhr.readyState === 4 && xhr.status === 200) {
                const audio = JSON.parse(xhr.responseText)

                if (audio.hasOwnProperty('ads')) {
                    audioPlayer.src = audio.ads
                    audioPlayer.hidden = false
                    audioPlayer.play()

                    audioPlayer.onended = function() {
                        audioPlayer.src = audio.data
                        audioPlayer.hidden = false
                        audioPlayer.play()
                    };
                } else {
                    audioPlayer.src = audio.data
                    audioPlayer.hidden = false
                    audioPlayer.play()
                }
            }
        }
        xhr.send();
    });
}

if (editButtons && editButtons.length > 0) {
    for (let item of editButtons) {
        item.addEventListener('click', (e) => {
            e.preventDefault();

            let id = item.id.substring(0, item.id.length - 2);

            window.location.href = '/music/edit?id=' + id;
        });
    }
}