const playButton = document.querySelector("#play-b")
const audioPlayer = document.querySelector("#audio")
const lyricsText = document.querySelector("#lyrics")
const lyricsBox = document.querySelector("#lyrics-box")

playButton && playButton.addEventListener("click", (e) => {
    e.preventDefault()

    const query = new URLSearchParams(window.location.search)
    const id = query.get("id")
    const xhr = new XMLHttpRequest()
    const url = "/audio?id="+id

    xhr.open('GET', url, true)
    xhr.onreadystatechange = function() {
        if (xhr.readyState === 4 && xhr.status === 200) {
            const audio = JSON.parse(xhr.responseText)

            if (audio.hasOwnProperty('ads')) {
                audioPlayer.src = audio.ads
                audioPlayer.hidden = false
                audioPlayer.play()

                audioPlayer.onended = function() {
                    audioPlayer.src = audio.data
                    audioPlayer.hidden = false
                    audioPlayer.play()
                };
            } else {
                audioPlayer.src = audio.data
                audioPlayer.hidden = false
                audioPlayer.play()
            }
        }
    }

    xhr.send()
})

let lyrics = false

lyricsText && lyricsText.addEventListener("click", (e) => {
    e.preventDefault()

    if (lyrics) {
        lyricsBox.hidden = true
        lyrics = false
        return
    } else {
        if (lyricsBox.innerHTML !== "") {
            lyricsBox.hidden = false
            lyrics = true
            return
        }
    }

    const query = new URLSearchParams(window.location.search)
    const id = query.get("id")
    const url = `http://localhost:3000/services/lyrics/${id}`
    const xhr = new XMLHttpRequest()

    xhr.open('GET', url)
    xhr.onreadystatechange = function() {
        lyricsBox.hidden = false
        lyrics = true
        if (xhr.readyState === 4 && xhr.status === 200) {
            const { message } = JSON.parse(xhr.responseText)
            lyricsBox.innerHTML = message
        } else {
            lyricsBox.innerHTML = "Lyrics not found."
        }
    }

    xhr.send()
})