<?php

require_once 'db/db-executor.php';
require_once 'auth/authenticator.php';
require_once 'auth/authorizer.php';

$errMsg = '';

// No token then login
if(!isset($_COOKIE['token'])) {
    header('Location: /login', true, 303);
    exit();
}

//Get id of account to verify user
$accountId = authenticateToken($_COOKIE['token']);

// For filtering
$allCreators = execSelect('SELECT DISTINCT username, account_id FROM account WHERE is_admin = CAST(1 AS SMALLINT)', []);


// Set limit and offset for pagination
$limit = 6;
$offset = 0;
// Get albums bsed on query
if(isset($_GET['q'])){
    $searchInput = $_GET['q'];
    $nameSearch = '%'.$searchInput.'%';
    $shownAlbums = execSelect('SELECT * FROM album WHERE name LIKE :searchQuery LIMIT :limit OFFSET :offset', ['searchQuery' => $nameSearch, 'limit' => $limit, 'offset' => $offset]);
    // Get pages number
    $elementCounts = execSelect('SELECT COUNT(album_id) AS element_count FROM album WHERE name LIKE :searchQuery',[ 'searchQuery' => $nameSearch])[0]['element_count'];
} else{
    $shownAlbums = execSelect('SELECT * FROM album LIMIT :limit OFFSET :offset', ['limit' => $limit, 'offset' => $offset]);
    $elementCounts = execSelect('SELECT COUNT(album_id) AS element_count FROM album',[ ])[0]['element_count'];
}
$pages = ceil($elementCounts / $limit);

require 'presentation/music/list/albumList.view.php';