<?php

require_once 'db/db-executor.php';
require_once 'auth/authenticator.php';

$errMsg = '';

// No token then login
if(!isset($_COOKIE['token'])) {
    header('Location: /login', true, 303);
    exit();
}

//Get id account to verify user
$accountId = authenticateToken($_COOKIE['token']);

// For filtering
$allGenres = execSelect('SELECT DISTINCT genre FROM music', []);
$allCreators = execSelect('SELECT DISTINCT username, account_id FROM account WHERE is_admin = CAST(1 AS SMALLINT)', []);

// Set limit and offset for pagination
$limit = 6;
$offset = 0;

// Get music bsed on query
if(isset($_GET['q'])){
    $searchInput = $_GET['q'];
    $nameSearch = '%'.$searchInput.'%';
    $shownMusics = execSelect('SELECT * FROM music WHERE title LIKE :searchQuery LIMIT :limit OFFSET :offset', ['searchQuery' => $nameSearch, 'limit' => $limit, 'offset' => $offset]);
    // Get pages number
    $elementCounts = execSelect('SELECT COUNT(music_id) AS element_count FROM music WHERE title LIKE :searchQuery',[ 'searchQuery' => $nameSearch])[0]['element_count'];

} else{
    $shownMusics = execSelect('SELECT * FROM music LIMIT :limit OFFSET :offset', ['limit' => $limit, 'offset' => $offset]);
    $elementCounts = execSelect('SELECT COUNT(music_id) AS element_count FROM music',[ ])[0]['element_count'];
}
$pages = ceil($elementCounts / $limit);

require 'presentation/music/list/musicList.view.php';