<? require_once 'util/album-finder.php'; ?>
<? require_once 'util/music-util.php'; ?>
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <link rel="stylesheet" type="text/css" href="presentation/music/list/css/musicList.css">
    <link rel="stylesheet" type="text/css" href="presentation/template/css/sidebar.css">
    <link rel="stylesheet" type="text/css" href="presentation/template/css/navbar.css">
    <link rel="preconnect" href="https://fonts.googleapis.com">
    <link rel="preconnect" href="https://fonts.gstatic.com" crossorigin>
    <link href="https://fonts.googleapis.com/css2?family=Roboto:wght@300;400;500&display=swap" rel="stylesheet">
    <script type="text/javascript" defer>
        const CSRF_TOKEN = "<?= $_COOKIE['token'] ?? '' ?>";
        const PAGES = parseInt("<?= $pages ?? 0 ?>");
        const LIMIT = 6;
    </script>
    <script type="text/javascript" src="presentation\music\list\js\musicList.js" defer></script>
    <title>Music list</title>
</head>
<body>
    <div class="wrapper">
    <!-- Sidebar -->
    <?php include('presentation/template/sidebar.php') ?>
        <div class="main-wrapper">
            <!-- Navigation Bar -->
            <?php include('presentation/template/navbar.php') ?>
            <section class="container-music">
                <div class="category">
                    <form class="search" method="GET">
                        <input class="input-search" type="text" placeholder="Search title or genre" value="<?php echo (isset($searchInput) ? $searchInput : null)?>">
                        <button class="search-button" type="submit"><img src="presentation\template\images\search.png" alt="Search"></button>
                    </form>
                    <!-- Sort  -->
                    <div class="sort">
                        <p>Sort by:</p>
                        <select class="sort-select">
                            <option value="title">Title</option>
                            <option value="year">Year</option>
                        </select>
                        <p>Order:</p>
                        <select class="order-select">
                            <option value="ASC">Ascending</option>
                            <option value="DESC">Descending</option>
                        </select>
                    </div>
                    <!-- Filter by genre or creator -->
                    <div class="filter">
                        <p>Genre:</p>
                        <select class="genre-select">
                            <option value="all">All</option>
                            <?php foreach ($allGenres as $row) { ?>
                                <option value="<?php echo $row['genre'] ?>"><?php echo $row['genre'] ?></option>
                            <?php } ?>
                        </select>
                        <p>Creator:</p>
                        <select class="creator-select">
                            <option value="all">All</option>
                            <?php foreach ($allCreators as $row) { ?>
                                <option value="<?php echo $row['account_id'] ?>"><?php echo $row['username'] ?></option>
                            <?php } ?>
                        </select>
                    </div>
                    <div class="music-wrapper">
                        <?php 
                            foreach ($shownMusics as $row) { ?>
                                <div class="music" id=<?php echo $row['music_id']?> >
                                    <img src="<? echo getAlbumImageByID($row['album_id'])?>" alt="Playlist 1">
                                    <h3><?php echo $row['title'] ?></h3>
                                    <h5><?php echo findAlbumNameById($row['album_id']) ?></h5>
                                    <p>By : <? echo getAlbumCreator($row['album_id']) ?></p>
                                    <p>Released : <?php echo $row['year'] ?></p>
                                    <p>ID : <?php echo $row['music_id'] ?></p>
                                </div>  
                        <?php } ?>
                    </div>
                    <div class="pagination">
                        <p id="pagination-text">Page <span id="page-number">1</span> of <span id="pages"><? echo $pages ?></span></p>
                        <div class="pagination-buttons">
                            <button id="prev-page" disabled>
                                <img src="presentation\images\prev-page.png" alt="left arr">
                            </button>
                            <button id="next-page" <?php if (false) : ?> disabled <? endif; ?>>
                                <img src="presentation/images/next-page.png" alt="right-arr">
                            </button>
                        </div>
                    </div>
                </div>
            </section>
        </div>
    </div>
</body>
</html>
