<?php

function isAlbumValid(string $albumId, string $accountId): bool {
    if (!is_numeric($albumId)) {
        return false;
    }
    $query = 'SELECT 1 FROM album where album_id=:albumId AND owner_account_id=:accountId';
    $params = [
        'albumId' => $albumId,
        'accountId' => $accountId
    ];

    $res = execSelect($query, $params);
    return !empty($res);
}

function isAlbumDataValid(string $albumName, string $year): bool {
    return strlen($albumName) <= 255 && is_numeric($year) && ((int)$year) >= 0;
}