<?php

function isMusicDataValid(string $title, string $genre, string $albumId, string $year): bool {
    $titleValid = strlen($title) <= 255;
    $genreValid = strlen($genre) <= 255;
    $albumIdValid = is_numeric($albumId) && (int) $albumId >= 0;
    $yearValid = is_numeric($year) && (int) $year >= 0;

    return $titleValid && $genreValid && $albumIdValid && $yearValid;
}

function findAlbumNameById(string $albumId): string {
    $albumName = execSelect('SELECT name FROM album WHERE album_id = :album_id', ['album_id' => $albumId])[0]['name'];
    return $albumName;
}